
%bcond_without mead
%define _jarsign_opts --copy=%{_javadir} --unsign=%{_javadir}

%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif


%define reltag .redhat_1
%define namedversion %{version}-redhat-1


%define maven_version 0.7.3-redhat-1

Name:           cal10n
Version:        0.7.3
Release:        5%{reltag}%{?dist}
Epoch:          0
Summary:        Compiler assisted localization library (CAL10N)
Group:          Development/Libraries

%if %with mead
Source100: ch.qos.cal10n-cal10n-parent-0.7.3-redhat-1-sources.zip
Source101: ch.qos.cal10n-cal10n-parent-0.7.3-redhat-1-patches.zip
Source102: cal10n-parent-0.7.3-redhat-1.pom
Source103: cal10n-api-0.7.3-redhat-1.pom
Source104: cal10n-api-0.7.3-redhat-1.jar
Source105: cal10n-api-0.7.3-redhat-1-javadoc.jar
Source106: cal10n-api-0.7.3-redhat-1-sources.jar
Source107: cal10n-api-0.7.3-redhat-1-tests.jar
%endif

License:        MIT
URL:            http://cal10n.qos.ch/
%if %without mead
Source0:        http://cal10n.qos.ch/dist/cal10n-%{version}.tar.gz
Patch0:         %{name}-%{version}-vman-poms.patch
%endif
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils

BuildRequires:       jpackage-utils
%if %without mead
BuildRequires:  commons-parent >= 0:9
BuildRequires:  junit4
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  maven2
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven2-plugin-site
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  vman
%endif

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Compiler Assisted Localization, abbreviated as CAL10N (pronounced as "calion") 
is a java library for writing localized (internationalized) messages.
Features:
    * java compiler verifies message keys used in source code
    * tooling to detect errors in message keys
    * native2ascii tool made superfluous, as you can directly encode bundles 
      in the most convenient charset, per locale.
    * good performance (300 nanoseconds per key look-up)
    * automatic reloading of resource bundles upon change

%if %without mead
%package javadoc
Group:          Documentation

Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
API documentation for %{name}.
%endif

%if %without mead
%package -n maven-cal10n-plugin
Summary:    CAL10N maven plugin
Group:      Development/Tools

Requires:   maven2
Requires:   %{name} = %{epoch}:%{version}-%{release}

%description -n maven-cal10n-plugin
Maven plugin verifying that the codes defined in
an enum type match those in the corresponding resource bundles. 
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q
%patch0 -p1
find -type f -name "*.jar" | xargs -t rm
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
# FIXME: cal10n-api/src/test/java/ch/qos/cal10n/util/MiscUtilTest.java:51 throws NPE
%{_bindir}/mvn-jpp -e -X -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.failure.ignore deploy javadoc:aggregate
%endif

%install
rm -rf %{buildroot}

# jars
install -d -m 0755 %{buildroot}%{_javadir}/%{name}
%if %without mead
install -p -m 644 cal10n-api/target/cal10n-api-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/cal10n-api-%{namedversion}.jar
install -p -m 644 maven-cal10n-plugin/target/maven-cal10n-plugin-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/maven-cal10n-plugin-%{namedversion}.jar
%else
install -p -m 644 %{_sourcedir}/cal10n-api-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/cal10n-api-%{namedversion}.jar
#install -p -m 644 %{_sourcedir}/maven-cal10n-plugin-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/maven-cal10n-plugin-%{namedversion}.jar
%endif
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; do ln -s ${jar} ${jar/-%{namedversion}/}; done)

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
%if %without mead
install -pm 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-parent.pom
install -pm 644 cal10n-api/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-api.pom
install -pm 644 maven-cal10n-plugin/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-maven-cal10n-plugin.pom
%else
install -pm 644 %{_sourcedir}/cal10n-parent-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-parent.pom
install -pm 644 %{_sourcedir}/cal10n-api-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-api.pom
#install -pm 644 %{_sourcedir}/maven-cal10n-plugin-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-maven-cal10n-plugin.pom
%endif

# depmaps
%add_to_maven_depmap ch.qos.cal10n cal10n-parent %{namedversion} JPP/%{name} cal10n-parent
%add_to_maven_depmap ch.qos.cal10n cal10n-api %{namedversion} JPP/%{name} cal10n-api
#%%add_to_maven_depmap ch.qos.cal10n maven-cal10n-plugin %{namedversion} JPP/%{name} maven-cal10n-plugin

%if %without mead
# javadoc
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
cp -pr target/site/api*/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*/%{name}
#%%exclude %dir %{_javadocdir}/%{name}
%{_javadir}*/%{name}/cal10n-api.jar
%{_javadir}*/%{name}/cal10n-api-%{namedversion}.jar
%{_datadir}/maven2/poms/JPP.%{name}-%{name}-parent.pom
%{_datadir}/maven2/poms/JPP.%{name}-%{name}-api.pom
%{_mavendepmapfragdir}/%{name}

%if %without mead
%files -n maven-cal10n-plugin
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/maven-cal10n-plugin-%{namedversion}.jar
%{_javadir}*/%{name}/maven-cal10n-plugin.jar
%{_datadir}/maven2/poms/JPP.%{name}-maven-cal10n-plugin.pom
%endif

%if %without mead
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Apr 18 2012 Hui Wang <huwang@redhat.com> 0:0.7.3-5.redhat_1
- Fix release tag
- Change jboss-parent's version to 8-redhat-1

* Fri Feb 24 2012 Fernando Nasser <fnasser@redhat.com> 0:0.7.3-4.1_redhat_1.4
- Populate javadir-signed

* Tue Feb 07 2012 Red Hat Release Engineering <release-engineering@redhat.com> - 0:0.7.3-4.1_redhat_1.1
- Rebuild to use new signing key

* Tue Jan 31 2012 Fernando Nasser <fnasser@redhat.com> 0:0.7.3-3.1_redhat_1.1
- Build with new wrapper from MEAD build

* Sun Jan 29 2012 Yong Yang <yyang@redhat.com> 0:0.7.3-3.1_redhat_1
- Build for werewolf

* Thu Aug 25 2011 David Walluck <dwalluck@redhat.com> 0:0.7.3-3
- Build for werewolf

* Thu Jul 07 2011 David Walluck <dwalluck@redhat.com> 0:0.7.3-2
- remove patch
- fix file list
- fix maven build

* Fri Dec 17 2010 David Walluck <dwalluck@redhat.com> 0:0.7.3-1
- 0.7.3
- fix maven-cal10n-plugin Requires
